package com.googlecode.genericdao.search;

import java.util.HashMap;
import java.util.Map;
import java.util.Objects;
import java.util.regex.Pattern;

/**
 * Created by petercipov on 30/06/16.
 */
public class MatcherContext {

    private final boolean caseIgnored;
    private final Map<String, Pattern> patternCache;

    public MatcherContext(boolean caseIgnored) {
        this.caseIgnored = caseIgnored;
        this.patternCache = new HashMap<>();
    }

    public boolean isCaseIgnored() {
        return this.caseIgnored;
    }

    public Object getProperty(String name) {
        Objects.requireNonNull(name, "name parameter was not set");
        return null;
    }

    public Pattern getPattern(String pattern) {
        if (pattern == null) {
            return null;
        }

        Pattern objectPattern = patternCache.get(pattern);
        if (objectPattern == null) {
            objectPattern = Matcher.sqlPatternToPattern(pattern, caseIgnored);
            patternCache.put(pattern, objectPattern);
        }

        return objectPattern;
    }
}
