package net.pricefx.common.api.chart;

import java.util.HashMap;
import java.util.Map;

public enum WaterfallColumnType {

	RESULT("RESULT"), 
	ADD("ADD"),
	SUBTRACT("SUBTRACT");

	private String value;
	
	private static final Map<String,WaterfallColumnType> lookupViaValue = new HashMap<String,WaterfallColumnType>(WaterfallColumnType.values().length + 1, 1);
	
	static {
	
		for(WaterfallColumnType columnType : WaterfallColumnType.values()) { 
	         lookupViaValue.put(columnType.value, columnType);
	    }
	
	}	    
	
    public static WaterfallColumnType getViaValue(String value) { 
       	return lookupViaValue.get(value); 
    }
	
	private WaterfallColumnType(String value) {
		this.value = value;
	}

	public String getValue() {
		return value;
	}

}
