package net.pricefx.common.apibuilder.calculationflowaction;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public final class MethodInvocationRecord {

	private MethodInvocationRecord(String fullName,  Object ... arguments) {
		_fullName = fullName;
		if (arguments == null || arguments.length == 0) 
			_arguments = Collections.emptyList();
		else
			_arguments = Collections.unmodifiableList(Arrays.asList(arguments));
	}
	
	private final String _fullName;
	private final List<Object> _arguments;
	
	@Override public String toString() { return _fullName; }

	public String fullName() { return _fullName; }
	public List<Object> arguments() {return _arguments; }
	
	public static MethodInvocationRecord of(String fullName, Object ... arguments) {
		return new MethodInvocationRecord(fullName, arguments);
	}

}