package net.pricefx.common.apibuilder.chart;

import net.pricefx.common.api.chart.SeriesType;
import net.pricefx.common.api.chart.WhiskerType;

public class ChartSeries {
	
	private ChartSeries() {
		throw new IllegalStateException("Utility class");
	}
	
	public abstract static class Basic<C extends AbstractChartBuilder<C>, S extends Basic<C, S>> extends AbstractChartSeries<C, S> {
		
		public Basic(final C backLink, final String instanceId) {
			super(backLink, instanceId);
		}
		
		@Override
		public final S setHideDataLabels(final Boolean hideDataLabels) {
			return super.setHideDataLabels(hideDataLabels);
		}
		
	}
	
	public abstract static class EmbeddedBoxplot<C extends AbstractChartBuilder<C>, S extends Basic<C, S>> extends Basic<C, S> {
		
		public EmbeddedBoxplot(final C backLink, final String instanceId) {
			super(backLink, instanceId);
		}
		
		@Override
		public final S setType(final SeriesType seriesType) {
			return super.setType(seriesType);
		}
		
		@Override
		public final S setShowBoxplot(final Boolean showBoxplot) {
			return super.setShowBoxplot(showBoxplot);
		}
		
		@Override
		public final NonAggrFieldAxis<S> setBoxplotAxis() {
			return super.setBoxplotAxis();
		}
		
		@Override
		public final S setWhisker(final WhiskerType whiskerType) {
			return super.setWhisker(whiskerType);
		}
		
	}
	
	public abstract static class Aggregation<C extends AbstractChartBuilder<C>, S extends Basic<C, S>> extends Basic<C, S> {
		
		public Aggregation(final C backLink, final String instanceId) {
			super(backLink, instanceId);
		}
		
		@Override
		public final S setAggregationBy(final String aggregationBy) {
			return super.setAggregationBy(aggregationBy);
		}
		
		@Override
		public final S setBandBy(final String bandBy) {
			return super.setBandBy(bandBy);
		}
		
		@Override
		public final S setShowBandByLegend(final Boolean showBandByLegend) {
			return super.setShowBandByLegend(showBandByLegend);
		}
		
	}
	
}
