package net.pricefx.common.apibuilder.quote;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import net.pricefx.common.apibuilder.clicoll.LineItemHelper;

/**
 * A helper class that assists in manipulating the quote object
 * 
 *
 */
public class QuoteHelper extends LineItemHelper {

	public QuoteHelper(Map<String, Object> calculableLineItemCollection) {
		super(calculableLineItemCollection);
	}

	/**
	 * Retrieves a list of all line items that are for a particular sku
	 * @param sku The sku to search for
	 * @return The list of line items
	 */
	@SuppressWarnings("unchecked")
	public List<LineItem> findAllWithSKU(String sku) {
		ArrayList<LineItem> is = new ArrayList<>();
		for (Entry<String, Object> e : idToLineItem.entrySet()) {
			Map<String, Object> lineItemMap = (Map<String, Object>) e.getValue();
			if (sku.equals(lineItemMap.get("sku"))) {
				is.add(lineItemFromMap(lineItemMap));
			}
		}
		return is;
	}
	
}
