package net.pricefx.common.apibuilder.rebateagreement;

import java.util.Map;

import net.pricefx.common.api.HeaderPhase;
import net.pricefx.common.apibuilder.IdGenerator;
import net.pricefx.common.apibuilder.Invocations;
import net.pricefx.common.apibuilder.MethodInvocation;

/**
 * 
 *  IMPORTANT: Please read super class notes on sequence of execution!
 *
 */
public class RebateAgreementBuilder extends BasicRebateAgreementBuilder<RebateAgreementBuilder> {

	// read only state, don't get propagated further, it is here for user convenience
	final private Object rebateAgreementView;	
	final private RebateAgreementHelper helper;
	
	@SuppressWarnings("unchecked")
	RebateAgreementBuilder(String instanceId, String classId, IdGenerator idGenerator, Invocations<MethodInvocation> invocations, Object rebateAgreementView, HeaderPhase phase) {
		super(instanceId, classId, idGenerator, invocations,phase);
		this.rebateAgreementView = rebateAgreementView;
		this.helper = new RebateAgreementHelper((Map<String, Object>)rebateAgreementView);
	}

	public Object getRebateAgreementView() {		
		addInvocation("getRebateAgreementView");		
		return rebateAgreementView;
	}
	
	public RebateAgreementHelper getHelper() {
		addInvocation("getHelper");		
		return helper;
	}

}