package net.pricefx.formulaengine.scripting.inputbuilder;

import net.pricefx.common.api.InputType;

import java.util.List;
import java.util.Map;

public class InputMatrixInputBuilder extends AbstractInputBuilder<InputMatrixInputBuilder,Object> {

    public InputMatrixInputBuilder(InputBuilderContext builderContext, String paramName) {
        super(builderContext, InputType.INPUTMATRIX, paramName);
    }

    public InputMatrixInputBuilder setColumns(List<String> columns) {
        cp.addParameterConfigEntry("columns", columns);
        return this;
    }

    public InputMatrixInputBuilder setReadOnlyColumns(List<String> readOnlyColumns) {
        cp.addParameterConfigEntry("readOnlyColumns", readOnlyColumns);
        return this;
    }

    public InputMatrixInputBuilder setFitFieldWidths(boolean value) {
        cp.setConfigParameter("fitFieldWidths", value);
        return this;
    }

    public InputMatrixInputBuilder setDefaultHeight(int value) {
        cp.setConfigParameter("defaultHeight", value);
        return this;
    }

    public InputMatrixInputBuilder setColumnValueOptions(Map value) {
        cp.setConfigParameter("columnValueOptions", value);
        return this;
    }

    public InputMatrixInputBuilder setCanModifyRows(boolean value) {
        cp.setConfigParameter("canModifyRows", value);
        return this;
    }

    public InputMatrixInputBuilder setNoCellRefresh(boolean value) {
        cp.setConfigParameter("noCellRefresh", value);
        return this;
    }

    public InputMatrixInputBuilder setFixTableHeight(boolean value) {
        cp.setConfigParameter("fixTableHeight", value);
        return this;
    }

}
