package net.pricefx.formulaengine.scripting.inputbuilder;

import net.pricefx.domain.LookupTable;
import net.pricefx.server.dto.calculation.ContextParameter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class VLookupBuilder extends AbstractInputBuilder<VLookupBuilder,Object> {

    private List<String> attributeNames;
    private Map<String,Object> keys;

    protected VLookupBuilder(InputBuilderContext builderContext, String paramName) {
        super(builderContext);

        LookupTable lt = null;

        cp = new ContextParameter(lt, builderContext.getEngineContext().getTargetDate());

    }

    public VLookupBuilder setAttributeName(String attributeName) {
        if(attributeNames == null)
            attributeNames = new ArrayList<String>();
        attributeNames.add(attributeName);

        return this;
    }

    public VLookupBuilder setAttributeNames(List<String> attributeNames) {
        this.attributeNames = attributeNames;
        return this;
    }

    public VLookupBuilder setKeys(Map keys) {
        this.keys = keys;
        return this;
    }

}
